<template>
    <v-row>
        <v-col>
            <v-card>
                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                    <v-container class="px-8">
                        <v-row>
                            <v-col>
                                <div class="title text--primary">
                                    {{ $t('user_', [$t('profile')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-divider></v-divider>

                        <v-row>
                            <v-col>
                                <div class="subtitle-1 text--secondary">
                                    {{ $t('user_', [$t('info')]) }}
                                </div>
                            </v-col>
                        </v-row>

                        <v-row class="ml-2">
                            <v-col cols="12" md="6">
                                <div class="field-label">{{ $t('first_name') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="first_name" rules="required">
                                    <v-text-field
                                        v-model="profile.first_name"
                                        :placeholder="$t('user_', [$t('first_name')])"
                                        :error-messages="errors"
                                        outlined
                                    >
                                    </v-text-field>
                                </ValidationProvider>
                            </v-col>

                            <v-col class="col-xs-12">
                                <div class="field-label">{{ $t('last_name') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="last_name" rules="required">
                                    <v-text-field
                                        v-model="profile.last_name"
                                        :placeholder="$t('user_', [$t('last_name')])"
                                        :error-messages="errors"
                                        outlined
                                    ></v-text-field>
                                </ValidationProvider>
                            </v-col>

                            <v-col class="col-xs-12 col-sm-12 col-md-12 col-lg-6">
                                <div class="field-label">{{ $t('mobile') }}</div>
                                <ValidationProvider v-slot="{ errors }" name="mobile" rules="required|mobile">
                                    <v-tel-input
                                        v-model="profile.mobile"
                                        :placeholder="$t('user_', [$t('mobile')])"
                                        :errors="errors"
                                    ></v-tel-input>
                                </ValidationProvider>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col class="text-center">
                                <v-btn
                                    class="text--white mx-2"
                                    color="primary"
                                    large
                                    :loading="submit"
                                    @click="save"
                                >
                                    <v-icon left>mdi-content-save</v-icon>
                                    {{ $t('save') }}
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-container>
                </ValidationObserver>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
    import {mapMutations, mapState} from 'vuex';
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import VTelInput from "../VTelInput";
    import VCountrySelect from "../VCountrySelect";

    export default {
        name: "UserProfile",
        components: {VCountrySelect, VTelInput, ValidationObserver, ValidationProvider},
        data: () => ({
            submit: false,
            oldEmail: '',
            profile: {
                first_name: '',
                last_name: '',
                mobile: ''
            },
            snackbar: {
                show: false,
                color: null,
                timeout: 6000,
                message: ''
            }
        }),

        computed: {
            ...mapState('auth', {
                localProfile: state => state.profile
            }),
        },

        mounted() {
            this.profile = {...this.localProfile};
        },

        methods: {
            ...mapMutations('snackbar', [
                'success'
            ]),

            save() {
                this.submit = true;

                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            this.$store.dispatch('auth/updateProfile', this.profile)
                                .then(() => {
                                    this.submit = false;
                                    this.success(this.$t('profile_action.updated'));
                                })
                                .catch(() => {
                                    this.submit = false;
                                });
                        }
                        else {
                            this.submit = false;
                        }
                    });
            }
        }
    }
</script>

<style scoped>
</style>
